.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ITaskbar.inc

ParamStruct STRUCT
	nID		DWORD		?
	hMenu	DWORD		?
	hBmp	DWORD		?
	dwFlags	DWORD		?
	szLabel	BYTE		32 DUP (?)
ParamStruct ends

REPARSE_DATA_BUF STRUCT
    ReparseTag dd           ?
    ReparseDataLength dw    ?
    Reserved dw             ?
    union
        struct SymbolicLinkReparse
            SubstituteNameOffset dw ?
            SubstituteNameLength dw ?
            PrintNameOffset dw      ?
            PrintNameLength dw      ?
            PathBuffer dw           ?
        ends
        struct MountPointReparse
            SubstituteNameOffset dw ?
            SubstituteNameLength dw ?
            PrintNameOffset dw      ?
            PrintNameLength dw      ?
            PathBuffer dw           ?
        ends
        struct GenericReparse
            DataBuffer db ?
        ends
    ends
REPARSE_DATA_BUF ENDS

REPARSE_GUID_DATA_BUF STRUCT
    ReparseTag dd           ?
    ReparseDataLength dw    ?
    Reserved dw             ?
    ReparseGuid GUID        <>
    struct GenericReparse
        DataBuffer db ?
    ends
REPARSE_GUID_DATA_BUF ENDS

REPARSE_STRUCT STRUCT
UNION
reparse_guid REPARSE_GUID_DATA_BUF <>
reparse_data REPARSE_DATA_BUF <>
ENDS
REPARSE_STRUCT ENDS

.data
tst db "this is a test",0
.data?

MyBuffer REPARSE_STRUCT <>
hInstance			dd ?

.code

mov eax,DWORD PTR [MyBuffer.reparse_guid.ReparseGuid]
mov ax,[MyBuffer.reparse_data.SymbolicLinkReparse.SubstituteNameOffset]

start:
	invoke CoInitialize,NULL
	invoke GetModuleHandle,NULL
	mov		hInstance,eax
    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke CoUninitialize
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		
	.elseif eax==WM_COMMAND
		.IF wParam == 1001
			invoke ShowTab,hWin,FALSE
		.ELSE
			invoke ShowTab,hWin,TRUE
		.ENDIF

	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0

	.else
		mov		eax,FALSE
		ret

	.endif

	mov		eax,TRUE
	ret

DlgProc endp



end start
