
include windows.inc
include kernel32.inc
include user32.inc
include Comctl32.inc
include shell32.inc
include Ole32.inc
include masm32.inc

; IID = 56FDF342-FD6D-11D0-958A-006097C9A090
; CLSID = B8DA6310-E198-11D0-933C-00A0C90DCAA9

includelib kernel32.lib
includelib user32.lib
includelib Comctl32.lib
includelib shell32.lib
includelib Ole32.lib
includelib masm32.lib

;include comdef.inc

DlgProc					PROTO	:HWND,:UINT,:WPARAM,:LPARAM
ShowTab				PROTO	:DWORD,:DWORD

include \RadASM\masm\inc\debug.inc
includelib \RadASM\masm\lib\debug.lib

DBGWIN_DEBUG_ON = 1 ; include debug info into the program
DBGWIN_EXT_INFO = 1 ; include extra debug info into the program 

IDD_DIALOG1				equ			101

;#########################################################################

Unknown STRUCT
	QueryInterface			DWORD		?
	AddRef					DWORD		?
	Release					DWORD		?
Unknown ends

ITaskbarList STRUCT
	IUnknown				Unknown		<>
	
	HrInit					DWORD	?
	AddTab					DWORD	?
	DeleteTab				DWORD	?
	ActivateTab				DWORD	?
	SetActiveAlt			DWORD	?
ITaskbarList ends

.const
	sCLSID_TaskbarList		textequ			<{056fdf344H, 0fd6dH, 011D0H,\
										{095H, 08ah, 000H, 060H, 097H, 0c9H, 0a0H, 090H}}>

	sIID_ITaskbarList		textequ			<{056FDF342H, 0FD6DH, 011D0H,\
										{095H, 08AH, 000H, 060H, 097H, 0C9H, 0A0H, 090H}}>

.data
	CLSID_ITaskbarList		GUID			sCLSID_TaskbarList
	IID_ITaskbarList		GUID			sIID_ITaskbarList

.code

ShowTab proc hWnd:DWORD,fShow:DWORD
	LOCAL ptb		:DWORD

	invoke CoCreateInstance,ADDR CLSID_ITaskbarList,NULL,CLSCTX_INPROC_SERVER,\
		ADDR IID_ITaskbarList,ADDR ptb
	.IF eax != S_OK
		mov eax,-1
		ret
	.endif

	push ptb
	mov edi,ptb
	mov edi,[edi]
	call [edi].ITaskbarList.HrInit
	.IF eax != S_OK
		push ptb
		call [edi].ITaskbarList.IUnknown.Release
		mov eax,-1
		ret
	.endif

	push hWnd
	push ptb
	.IF fShow
		call [edi].ITaskbarList.AddTab
	.ELSE
		call [edi].ITaskbarList.DeleteTab
	.ENDIF
	.IF eax != S_OK
		push ptb
		call [edi].ITaskbarList.IUnknown.Release
		mov eax,-1
		ret
	.endif

	push ptb
	call [edi].ITaskbarList.IUnknown.Release

	xor eax,eax

	ret
ShowTab endp

;#########################################################################
